SDL_mouse.h File Reference
`#include "SDL_stdinc.h"`
`#include "SDL_error.h"`
`#include "SDL_video.h"`
`#include "begin_code.h"`
`#include "close_code.h"`
Include dependency graph for SDL_mouse.h:
This graph shows which files directly or indirectly include this file:

Go to the source code of this file.

## Macros

#define | SDL_BUTTON(X)
#define | SDL_BUTTON_LEFT 1
#define | SDL_BUTTON_MIDDLE 2
#define | SDL_BUTTON_RIGHT 3
#define | SDL_BUTTON_X1 4
#define | SDL_BUTTON_X2 5
#define | SDL_BUTTON_LMASK SDL_BUTTON(SDL_BUTTON_LEFT)
#define | SDL_BUTTON_MMASK SDL_BUTTON(SDL_BUTTON_MIDDLE)
#define | SDL_BUTTON_RMASK SDL_BUTTON(SDL_BUTTON_RIGHT)
#define | SDL_BUTTON_X1MASK SDL_BUTTON(SDL_BUTTON_X1)
#define | SDL_BUTTON_X2MASK SDL_BUTTON(SDL_BUTTON_X2)

## Typedefs

typedef struct SDL_Cursor | SDL_Cursor

## Enumerations

enum | SDL_SystemCursor { SDL_SYSTEM_CURSOR_ARROW , SDL_SYSTEM_CURSOR_IBEAM , SDL_SYSTEM_CURSOR_WAIT , SDL_SYSTEM_CURSOR_CROSSHAIR , SDL_SYSTEM_CURSOR_WAITARROW , SDL_SYSTEM_CURSOR_SIZENWSE , SDL_SYSTEM_CURSOR_SIZENESW , SDL_SYSTEM_CURSOR_SIZEWE , SDL_SYSTEM_CURSOR_SIZENS , SDL_SYSTEM_CURSOR_SIZEALL , SDL_SYSTEM_CURSOR_NO , SDL_SYSTEM_CURSOR_HAND , SDL_NUM_SYSTEM_CURSORS }
enum | SDL_MouseWheelDirection { SDL_MOUSEWHEEL_NORMAL , SDL_MOUSEWHEEL_FLIPPED }

## Functions

SDL_Window * | SDL_GetMouseFocus (void)
Uint32 | SDL_GetMouseState (int *x, int *y)
Uint32 | SDL_GetGlobalMouseState (int *x, int *y)
Uint32 | SDL_GetRelativeMouseState (int *x, int *y)
void | SDL_WarpMouseInWindow (SDL_Window *window, int x, int y)
int | SDL_WarpMouseGlobal (int x, int y)
int | SDL_SetRelativeMouseMode (SDL_bool enabled)
int | SDL_CaptureMouse (SDL_bool enabled)
SDL_bool | SDL_GetRelativeMouseMode (void)
SDL_Cursor * | SDL_CreateCursor (const Uint8 *data, const Uint8 *mask, int w, int h, int hot_x, int hot_y)
SDL_Cursor * | SDL_CreateColorCursor (SDL_Surface *surface, int hot_x, int hot_y)
SDL_Cursor * | SDL_CreateSystemCursor (SDL_SystemCursor id)
void | SDL_SetCursor (SDL_Cursor *cursor)
SDL_Cursor * | SDL_GetCursor (void)
SDL_Cursor * | SDL_GetDefaultCursor (void)
void | SDL_FreeCursor (SDL_Cursor *cursor)
int | SDL_ShowCursor (int toggle)

## Macro Definition Documentation

## SDL_BUTTON

#define SDL_BUTTON | ( |  | X | ) |

Value:
(1 << ((X)-1))

Used as a mask when testing buttons in buttonstate.

- Button 1: Left mouse button
- Button 2: Middle mouse button
- Button 3: Right mouse button

Definition at line 444 of file SDL_mouse.h.

## SDL_BUTTON_LEFT

#define SDL_BUTTON_LEFT 1

Definition at line 445 of file SDL_mouse.h.

## SDL_BUTTON_LMASK

#define SDL_BUTTON_LMASK SDL_BUTTON(SDL_BUTTON_LEFT)

Definition at line 450 of file SDL_mouse.h.

## SDL_BUTTON_MIDDLE

#define SDL_BUTTON_MIDDLE 2

Definition at line 446 of file SDL_mouse.h.

## SDL_BUTTON_MMASK

#define SDL_BUTTON_MMASK SDL_BUTTON(SDL_BUTTON_MIDDLE)

Definition at line 451 of file SDL_mouse.h.

## SDL_BUTTON_RIGHT

#define SDL_BUTTON_RIGHT 3

Definition at line 447 of file SDL_mouse.h.

## SDL_BUTTON_RMASK

#define SDL_BUTTON_RMASK SDL_BUTTON(SDL_BUTTON_RIGHT)

Definition at line 452 of file SDL_mouse.h.

## SDL_BUTTON_X1

#define SDL_BUTTON_X1 4

Definition at line 448 of file SDL_mouse.h.

## SDL_BUTTON_X1MASK

#define SDL_BUTTON_X1MASK SDL_BUTTON(SDL_BUTTON_X1)

Definition at line 453 of file SDL_mouse.h.

## SDL_BUTTON_X2

#define SDL_BUTTON_X2 5

Definition at line 449 of file SDL_mouse.h.

## SDL_BUTTON_X2MASK

#define SDL_BUTTON_X2MASK SDL_BUTTON(SDL_BUTTON_X2)

Definition at line 454 of file SDL_mouse.h.

## Typedef Documentation

## SDL_Cursor

typedef struct SDL_Cursor SDL_Cursor

# CategoryMouse

Include file for SDL mouse event handling. Implementation dependent

Definition at line 41 of file SDL_mouse.h.

## Enumeration Type Documentation

## SDL_MouseWheelDirection

enum SDL_MouseWheelDirection

Scroll direction types for the Scroll event

Enumerator
SDL_MOUSEWHEEL_NORMAL | The scroll direction is normal
SDL_MOUSEWHEEL_FLIPPED | The scroll direction is flipped / natural

Definition at line 66 of file SDL_mouse.h.

{
SDL_MOUSEWHEEL_NORMAL, /**< The scroll direction is normal */
SDL_MOUSEWHEEL_FLIPPED /**< The scroll direction is flipped / natural */
} SDL_MouseWheelDirection;
SDL_MouseWheelDirection
SDL_MouseWheelDirection
Definition SDL_mouse.h:67
SDL_MOUSEWHEEL_NORMAL
@ SDL_MOUSEWHEEL_NORMAL
Definition SDL_mouse.h:68
SDL_MOUSEWHEEL_FLIPPED
@ SDL_MOUSEWHEEL_FLIPPED
Definition SDL_mouse.h:69

## SDL_SystemCursor

enum SDL_SystemCursor

Cursor types for SDL_CreateSystemCursor().

Enumerator
SDL_SYSTEM_CURSOR_ARROW | Arrow
SDL_SYSTEM_CURSOR_IBEAM | I-beam
SDL_SYSTEM_CURSOR_WAIT | Wait
SDL_SYSTEM_CURSOR_CROSSHAIR | Crosshair
SDL_SYSTEM_CURSOR_WAITARROW | Small wait cursor (or Wait if not available)
SDL_SYSTEM_CURSOR_SIZENWSE | Double arrow pointing northwest and southeast
SDL_SYSTEM_CURSOR_SIZENESW | Double arrow pointing northeast and southwest
SDL_SYSTEM_CURSOR_SIZEWE | Double arrow pointing west and east
SDL_SYSTEM_CURSOR_SIZENS | Double arrow pointing north and south
SDL_SYSTEM_CURSOR_SIZEALL | Four pointed arrow pointing north, south, east, and west
SDL_SYSTEM_CURSOR_NO | Slashed circle or crossbones
SDL_SYSTEM_CURSOR_HAND | Hand
SDL_NUM_SYSTEM_CURSORS |

Definition at line 46 of file SDL_mouse.h.

{
SDL_SYSTEM_CURSOR_ARROW, /**< Arrow */
SDL_SYSTEM_CURSOR_IBEAM, /**< I-beam */
SDL_SYSTEM_CURSOR_WAIT, /**< Wait */
SDL_SYSTEM_CURSOR_CROSSHAIR, /**< Crosshair */
SDL_SYSTEM_CURSOR_WAITARROW, /**< Small wait cursor (or Wait if not available) */
SDL_SYSTEM_CURSOR_SIZENWSE, /**< Double arrow pointing northwest and southeast */
SDL_SYSTEM_CURSOR_SIZENESW, /**< Double arrow pointing northeast and southwest */
SDL_SYSTEM_CURSOR_SIZEWE, /**< Double arrow pointing west and east */
SDL_SYSTEM_CURSOR_SIZENS, /**< Double arrow pointing north and south */
SDL_SYSTEM_CURSOR_SIZEALL, /**< Four pointed arrow pointing north, south, east, and west */
SDL_SYSTEM_CURSOR_NO, /**< Slashed circle or crossbones */
SDL_SYSTEM_CURSOR_HAND, /**< Hand */
SDL_NUM_SYSTEM_CURSORS
} SDL_SystemCursor;
SDL_SystemCursor
SDL_SystemCursor
Definition SDL_mouse.h:47
SDL_SYSTEM_CURSOR_SIZENS
@ SDL_SYSTEM_CURSOR_SIZENS
Definition SDL_mouse.h:56
SDL_SYSTEM_CURSOR_HAND
@ SDL_SYSTEM_CURSOR_HAND
Definition SDL_mouse.h:59
SDL_SYSTEM_CURSOR_ARROW
@ SDL_SYSTEM_CURSOR_ARROW
Definition SDL_mouse.h:48
SDL_SYSTEM_CURSOR_SIZENWSE
@ SDL_SYSTEM_CURSOR_SIZENWSE
Definition SDL_mouse.h:53
SDL_SYSTEM_CURSOR_SIZENESW
@ SDL_SYSTEM_CURSOR_SIZENESW
Definition SDL_mouse.h:54
SDL_SYSTEM_CURSOR_IBEAM
@ SDL_SYSTEM_CURSOR_IBEAM
Definition SDL_mouse.h:49
SDL_SYSTEM_CURSOR_NO
@ SDL_SYSTEM_CURSOR_NO
Definition SDL_mouse.h:58
SDL_SYSTEM_CURSOR_WAITARROW
@ SDL_SYSTEM_CURSOR_WAITARROW
Definition SDL_mouse.h:52
SDL_SYSTEM_CURSOR_SIZEALL
@ SDL_SYSTEM_CURSOR_SIZEALL
Definition SDL_mouse.h:57
SDL_SYSTEM_CURSOR_WAIT
@ SDL_SYSTEM_CURSOR_WAIT
Definition SDL_mouse.h:50
SDL_NUM_SYSTEM_CURSORS
@ SDL_NUM_SYSTEM_CURSORS
Definition SDL_mouse.h:60
SDL_SYSTEM_CURSOR_SIZEWE
@ SDL_SYSTEM_CURSOR_SIZEWE
Definition SDL_mouse.h:55
SDL_SYSTEM_CURSOR_CROSSHAIR
@ SDL_SYSTEM_CURSOR_CROSSHAIR
Definition SDL_mouse.h:51

## Function Documentation

## SDL_CaptureMouse()

int SDL_CaptureMouse | ( | SDL_bool | enabled | ) |

extern

Capture the mouse and to track input outside an SDL window.

Capturing enables your app to obtain mouse events globally, instead of just within your window. Not all video targets support this function. When capturing is enabled, the current window will get all mouse events, but unlike relative mode, no change is made to the cursor and it is not restrained to your window.

This function may also deny mouse input to other windows–both those in your application and others on the system–so you should use this function sparingly, and in small bursts. For example, you might want to track the mouse while the user is dragging something, until the user releases a mouse button. It is not recommended that you capture the mouse for long periods of time, such as the entire time your app is running. For that, you should probably use SDL_SetRelativeMouseMode() or SDL_SetWindowGrab(), depending on your goals.

While captured, mouse events still report coordinates relative to the current (foreground) window, but those coordinates may be outside the bounds of the window (including negative values). Capturing is only allowed for the foreground window. If the window loses focus while capturing, the capture will be disabled automatically.

While capturing is enabled, the current window will have the SDL_WINDOW_MOUSE_CAPTURE flag set.

Please note that as of SDL 2.0.22, SDL will attempt to "auto capture" the mouse while the user is pressing a button; this is to try and make mouse behavior more consistent between platforms, and deal with the common case of a user dragging the mouse outside of the window. This means that if you are calling SDL_CaptureMouse() only to deal with this situation, you no longer have to (although it is safe to do so). If this causes problems for your app, you can disable auto capture by setting the SDL_HINT_MOUSE_AUTO_CAPTURE hint to zero.

Parameters

  enabled | SDL_TRUE to enable capturing, SDL_FALSE to disable.

Returns
  0 on success or -1 if not supported; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.4.

See also
  SDL_GetGlobalMouseState

## SDL_CreateColorCursor()

SDL_Cursor * SDL_CreateColorCursor | ( | SDL_Surface * | surface,
|  | int | hot_x,
|  | int | hot_y )

extern

Create a color cursor.

Parameters

  surface | an SDL_Surface structure representing the cursor image.
  hot_x | the x position of the cursor hot spot.
  hot_y | the y position of the cursor hot spot.

Returns
  the new cursor on success or NULL on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_CreateCursor
  SDL_FreeCursor

## SDL_CreateCursor()

SDL_Cursor * SDL_CreateCursor | ( | const Uint8 * | data,
|  | const Uint8 * | mask,
|  | int | w,
|  | int | h,
|  | int | hot_x,
|  | int | hot_y )

extern

Create a cursor using the specified bitmap data and mask (in MSB format).

mask has to be in MSB (Most Significant Bit) format.

The cursor width (w) must be a multiple of 8 bits.

The cursor is created in black and white according to the following:

- data=0, mask=1: white
- data=1, mask=1: black
- data=0, mask=0: transparent
- data=1, mask=0: inverted color if possible, black if not.

Cursors created with this function must be freed with SDL_FreeCursor().

If you want to have a color cursor, or create your cursor from an SDL_Surface, you should use SDL_CreateColorCursor(). Alternately, you can hide the cursor and draw your own as part of your game's rendering, but it will be bound to the framerate.

Also, since SDL 2.0.0, SDL_CreateSystemCursor() is available, which provides twelve readily available system cursors to pick from.

Parameters

  data | the color value for each pixel of the cursor.
  mask | the mask value for each pixel of the cursor.
  w | the width of the cursor.
  h | the height of the cursor.
  hot_x | the X-axis location of the upper left corner of the cursor relative to the actual mouse position.
  hot_y | the Y-axis location of the upper left corner of the cursor relative to the actual mouse position.

Returns
  a new cursor with the specified parameters on success or NULL on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_FreeCursor
  SDL_SetCursor
  SDL_ShowCursor

## SDL_CreateSystemCursor()

SDL_Cursor * SDL_CreateSystemCursor | ( | SDL_SystemCursor | id | ) |

extern

Create a system cursor.

Parameters

  id | an SDL_SystemCursor enum value.

Returns
  a cursor on success or NULL on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_FreeCursor

## SDL_FreeCursor()

void SDL_FreeCursor | ( | SDL_Cursor * | cursor | ) |

extern

Free a previously-created cursor.

Use this function to free cursor resources created with SDL_CreateCursor(), SDL_CreateColorCursor() or SDL_CreateSystemCursor().

Parameters

  cursor | the cursor to free.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_CreateColorCursor
  SDL_CreateCursor
  SDL_CreateSystemCursor

## SDL_GetCursor()

SDL_Cursor * SDL_GetCursor | ( | void |  | ) |

extern

Get the active cursor.

This function returns a pointer to the current cursor which is owned by the library. It is not necessary to free the cursor with SDL_FreeCursor().

Returns
  the active cursor or NULL if there is no mouse.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_SetCursor

## SDL_GetDefaultCursor()

SDL_Cursor * SDL_GetDefaultCursor | ( | void |  | ) |

extern

Get the default cursor.

You do not have to call SDL_FreeCursor() on the return value, but it is safe to do so.

Returns
  the default cursor on success or NULL on failure.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_CreateSystemCursor

## SDL_GetGlobalMouseState()

Uint32 SDL_GetGlobalMouseState | ( | int * | x,
|  | int * | y )

extern

Get the current state of the mouse in relation to the desktop.

This works similarly to SDL_GetMouseState(), but the coordinates will be reported relative to the top-left of the desktop. This can be useful if you need to track the mouse outside of a specific window and SDL_CaptureMouse() doesn't fit your needs. For example, it could be useful if you need to track the mouse while dragging a window, where coordinates relative to a window might not be in sync at all times.

Note: SDL_GetMouseState() returns the mouse position as SDL understands it from the last pump of the event queue. This function, however, queries the OS for the current mouse position, and as such, might be a slightly less efficient function. Unless you know what you're doing and have a good reason to use this function, you probably want SDL_GetMouseState() instead.

Parameters

  x | filled in with the current X coord relative to the desktop; can be NULL.
  y | filled in with the current Y coord relative to the desktop; can be NULL.

Returns
  the current button state as a bitmask which can be tested using the SDL_BUTTON(X) macros.

Since
  This function is available since SDL 2.0.4.

See also
  SDL_CaptureMouse

## SDL_GetMouseFocus()

SDL_Window * SDL_GetMouseFocus | ( | void |  | ) |

extern

Get the window which currently has mouse focus.

Returns
  the window with mouse focus.

Since
  This function is available since SDL 2.0.0.

## SDL_GetMouseState()

Uint32 SDL_GetMouseState | ( | int * | x,
|  | int * | y )

extern

Retrieve the current state of the mouse.

The current button state is returned as a button bitmask, which can be tested using the SDL_BUTTON(X) macros (where X is generally 1 for the left, 2 for middle, 3 for the right button), and x and y are set to the mouse cursor position relative to the focus window. You can pass NULL for either x or y.

Parameters

  x | the x coordinate of the mouse cursor position relative to the focus window.
  y | the y coordinate of the mouse cursor position relative to the focus window.

Returns
  a 32-bit button bitmask of the current button state.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_GetGlobalMouseState
  SDL_GetRelativeMouseState
  SDL_PumpEvents

## SDL_GetRelativeMouseMode()

SDL_bool SDL_GetRelativeMouseMode | ( | void |  | ) |

extern

Query whether relative mouse mode is enabled.

Returns
  SDL_TRUE if relative mode is enabled or SDL_FALSE otherwise.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_SetRelativeMouseMode

## SDL_GetRelativeMouseState()

Uint32 SDL_GetRelativeMouseState | ( | int * | x,
|  | int * | y )

extern

Retrieve the relative state of the mouse.

The current button state is returned as a button bitmask, which can be tested using the SDL_BUTTON(X) macros (where X is generally 1 for the left, 2 for middle, 3 for the right button), and x and y are set to the mouse deltas since the last call to SDL_GetRelativeMouseState() or since event initialization. You can pass NULL for either x or y.

Parameters

  x | a pointer filled with the last recorded x coordinate of the mouse.
  y | a pointer filled with the last recorded y coordinate of the mouse.

Returns
  a 32-bit button bitmask of the relative button state.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_GetMouseState

## SDL_SetCursor()

void SDL_SetCursor | ( | SDL_Cursor * | cursor | ) |

extern

Set the active cursor.

This function sets the currently active cursor to the specified one. If the cursor is currently visible, the change will be immediately represented on the display. SDL_SetCursor(NULL) can be used to force cursor redraw, if this is desired for any reason.

Parameters

  cursor | a cursor to make active.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_CreateCursor
  SDL_GetCursor
  SDL_ShowCursor

## SDL_SetRelativeMouseMode()

int SDL_SetRelativeMouseMode | ( | SDL_bool | enabled | ) |

extern

Set relative mouse mode.

While the mouse is in relative mode, the cursor is hidden, the mouse position is constrained to the window, and SDL will report continuous relative mouse motion even if the mouse is at the edge of the window.

This function will flush any pending mouse motion.

Parameters

  enabled | SDL_TRUE to enable relative mode, SDL_FALSE to disable.

Returns
  0 on success or a negative error code on failure; call SDL_GetError() for more information.

If relative mode is not supported, this returns -1.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_GetRelativeMouseMode

## SDL_ShowCursor()

int SDL_ShowCursor | ( | int | toggle | ) |

extern

Toggle whether or not the cursor is shown.

The cursor starts off displayed but can be turned off. Passing SDL_ENABLE displays the cursor and passing SDL_DISABLE hides it.

The current state of the mouse cursor can be queried by passing SDL_QUERY; either SDL_DISABLE or SDL_ENABLE will be returned.

Parameters

  toggle | SDL_ENABLE to show the cursor, SDL_DISABLE to hide it, SDL_QUERY to query the current state without changing it.

Returns
  SDL_ENABLE if the cursor is shown, or SDL_DISABLE if the cursor is hidden, or a negative error code on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_CreateCursor
  SDL_SetCursor

## SDL_WarpMouseGlobal()

int SDL_WarpMouseGlobal | ( | int | x,
|  | int | y )

extern

Move the mouse to the given position in global screen space.

This function generates a mouse motion event.

A failure of this function usually means that it is unsupported by a platform.

Note that this function will appear to succeed, but not actually move the mouse when used over Microsoft Remote Desktop.

Parameters

  x | the x coordinate.
  y | the y coordinate.

Returns
  0 on success or a negative error code on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.4.

See also
  SDL_WarpMouseInWindow

## SDL_WarpMouseInWindow()

void SDL_WarpMouseInWindow | ( | SDL_Window * | window,
|  | int | x,
|  | int | y )

extern

Move the mouse cursor to the given position within the window.

This function generates a mouse motion event if relative mode is not enabled. If relative mode is enabled, you can force mouse events for the warp by setting the SDL_HINT_MOUSE_RELATIVE_WARP_MOTION hint.

Note that this function will appear to succeed, but not actually move the mouse when used over Microsoft Remote Desktop.

Parameters

  window | the window to move the mouse into, or NULL for the current mouse focus.
  x | the x coordinate within the window.
  y | the y coordinate within the window.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_WarpMouseGlobal